package com.engine.organization.service;

import com.engine.organization.entity.TreeData;
import com.engine.organization.entity.scheme.param.LevelSearchParam;
import com.engine.organization.util.MenuBtn;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @description:
 * @author:dxfeng
 * @createTime: 2022/05/10
 * @version: 1.0
 */
public interface LevelService {
    /**
     * 职等列表
     *
     * @param params
     * @return
     */
    Map<String, Object> listPage(Map<String, Object> params);

    /**
     * 新增职等
     * @param param
     * @return
     */
    int saveLevel(LevelSearchParam param);

    /**
     * 更新职等信息
     *
     * @param param
     * @return
     */
    int updateLevel(LevelSearchParam param);

    /**
     * 更新禁用标记
     *
     * @param params
     */
    int updateForbiddenTagById(LevelSearchParam params);

    /**
     * 根据ID批量删除
     *
     * @param ids
     */
    int deleteByIds(Collection<Long> ids);

    /**
     * 获取搜索条件
     *
     * @param params
     * @return
     */
    Map<String, Object> getSearchCondition(Map<String, Object> params);


    /**
     * 获取新增表单
     *
     * @param params
     * @return
     */
    Map<String, Object> getLevelForm(Map<String, Object> params);

    /**
     * 获取列表页面按钮信息
     * @return
     */
    Map<String, List<MenuBtn>> getTableBtn();

    /**
     * 获取列表tabs
     * @return
     */
    Map<String, Object> getTabInfo();

    /**
     * 获取左侧树
     *
     * @return
     */
    TreeData getTreeData();

}
